/**
 * @Module Name: 1Pay Payments | Magento
 * Plugin URI: http://1pay.in
 * Description: Extends Magento with 1Pay services
 * Version: 1.0.2
 * @author: Soumil Gada
 * Author EMAIL: soumil.gada@mobilewaretech.com
 * @copyright: @2018 Mobilewaretech. All rights reserved
 */

/*browser:true*/
/*global define*/
define(["Magento_Checkout/js/view/payment/default", "mage/url"], function(
  Component,
  url
) {
  "use strict";

  return Component.extend({
    defaults: {
      template: "MwtUM_Onepay/payment/onepay-form"
    },
    redirectAfterPlaceOrder: false,
    /**
     * After place order callback
     */
    afterPlaceOrder: function() {
      jQuery("#opayloader").show();
      jQuery(function($) {
        $.ajax({
          url: url.build("onepay/checkout/start"),
          type: "get",
          dataType: "json",
          showLoader: true, // enable loader
          cache: false,
          processData: false, // Don't process the files
          contentType: false, // Set content type to false as jQuery will tell the server its a query string request
          success: function(data) {
            var htmlForm = JSON.parse(data.html);
            if (data["html"] === "failure") {
              alert("Checksum error");
            } else {
              $("body").append(htmlForm);
              $("#1pay_form").submit();
            }
          },
          error: function(xhr, ajaxOptions, thrownError) {
            alert(
              thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText
            );
          }
        });
      });
    }
  });
});
